
Imports System.Runtime.InteropServices


Public Class Ctccom32v2
    '
    '  MODULE:   ctccom32v2.bas
    '
    '  PURPOSE:
    '    Contains declarations for Ctccom32v2 DLL.
    '

    ' constants for binary protocol
    Public Const CT_ASCII As Integer = 10
    Public Const CT_REQUEST As Integer = 20
    Public Const CT_REPLY As Integer = 21
    Public Const CT_ACK As Integer = 100
    Public Const CT_NAK As Integer = 101
    Public Const CT_RANGE As Integer = 102
    Public Const CT_VALUE As Integer = 104

    ' function return values
    Public Const FAILURE As Integer = 0
    Public Const SUCCESS As Integer = 1
    Public Const ERROR_UNKNOWN As Integer = 255
    Public Const ERROR_WIN_TIMER As Integer = 246
    Public Const ERROR_NET_TIMEOUT As Integer = 236
    Public Const ERROR_NET_NOTREADY As Integer = 235
    Public Const ERROR_CT_RANGE As Integer = 216
    Public Const ERROR_BAD_CHECKSUM As Integer = 215
    Public Const ERROR_BAD_LENGTH As Integer = 214
    Public Const ERROR_BAD_RESPONSE As Integer = 206
    Public Const ERROR_NOT_CT_PROTOCOL As Integer = 205
    Public Const ERROR_UNSUPP_REMOTE_OPER As Integer = 196
    Public Const ERROR_UNKNOWN_REM_NODE As Integer = 195
    Public Const ERROR_REMOTE_ACCESS As Integer = 194
    Public Const ERROR_OBJECT_FILE_NOT_FOUND As Integer = 186
    Public Const ERROR_FILE_WRONG_ARCH As Integer = 185
    Public Const ERROR_FILE_NOT_OBJECT As Integer = 184
    Public Const ERROR_BAD_OBJECT_RECORD As Integer = 183
    Public Const ERROR_BAD_OBJECT_LENGTH As Integer = 182
    Public Const ERROR_BAD_POSITION As Integer = 181
    Public Const ERROR_EOF As Integer = 180
    Public Const ERROR_BAD_PORT As Integer = 179
    Public Const ERROR_NET_IN_USE As Integer = 178
    Public Const ERROR_SERIAL_TIMEOUT As Integer = 170
    Public Const ERROR_WARNING As Integer = 169
    Public Const ERROR_ILLEGAL_BAUD_RATE As Integer = 168
    Public Const ERROR_ILLEGAL_PARITY_SETTING As Integer = 167
    Public Const ERROR_ILLEGAL_WORD_LENGTH As Integer = 166
    Public Const ERROR_ILLEGAL_STOP_BITS As Integer = 165
    Public Const ERROR_ERROR As Integer = 160
    Public Const ERROR_PORT_NOT_FOUND As Integer = 159
    Public Const ERROR_PORT_IN_USE As Integer = 158

    ' Constants for port Structures
    Public Const NO_PORT As Integer = 0
    Public Const SERIAL As Integer = 1
    Public Const CTCNET As Integer = 2
    Public Const CTCUDP As Integer = 3
    Public Const CTCTCP As Integer = 4

    ' Constants for Parity
    Public Const NO_PARITY As Byte = 0
    Public Const ODD_PARITY As Byte = 1
    Public Const EVEN_PARITY As Byte = 2
    Public Const MARK_PARITY As Byte = 3
    Public Const SPACE_PARITY As Byte = 4

    ' Constants for Data Bits
    Public Const FOUR_DATA_BITS As Byte = 4
    Public Const FIVE_DATA_BITS As Byte = 5
    Public Const SIX_DATA_BITS As Byte = 6
    Public Const SEVEN_DATA_BITS As Byte = 7
    Public Const EIGHT_DATA_BITS As Byte = 8

    ' Constants for Stop Bits
    Public Const ONE_STOP_BITS As Byte = 0
    Public Const ONE_FIVE_STOP_BITS As Byte = 1
    Public Const TWO_STOP_BITS As Byte = 2

    ' program file statistics
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_PROG_COUNTS
        Dim lSteps As Integer
        Dim lBytes As Integer
        Dim lErrors As Integer
        Dim lWarnings As Integer
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure RANDOM_VARIANT
        Dim register As Integer
        Dim row As Integer
        Dim col As Integer
    End Structure

    ' 2217 Block Read
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_2217DATA
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=128)> _
        Public lAnalIn() As Integer          '(0 To 127)
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=128)> _
        Public lAnalOut() As Integer     '(0 To 127)
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=10)> _
        Public lDigIn() As Integer     '(0 To 9)
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=10)> _
        Public lDigOut() As Integer     '(0 To 9)
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=100)> _
        Public lReg() As Integer     '(0 To 99)
    End Structure


    'Variant types to return and write
    Public Const CT_VARIANT_INTEGER As Integer = 1
    Public Const CT_VARIANT_UINTEGER As Integer = 2
    Public Const CT_VARIANT_STRING As Integer = 4
    Public Const CT_VARIANT_FLOAT As Integer = 8
    Public Const CT_VARIANT_DOUBLE As Integer = 16

    Public Const CT_VARIANT_DOUBLE_NOSWAP_FLAG As Integer = 32
    Public Const CT_VARIANT_INDIRECTION_FLAG As Integer = 64

    Public Const CT_MAX_STRING_SIZE As Integer = 223

    'Maximum variant transfers allowed for UDP and TCP (CTNET not supported)
    Public Const MAX_VARIANT_BLOCK_32BITS As Integer = 346
    Public Const MAX_VARIANT_BLOCK_64BITS As Integer = 173
    Public Const MAX_VARIANT_RANDOM_BLOCK As Integer = 115

    'Maximum variant transfers allowed for Serial
    Public Const MAX_VARIANT_BLOCK_32BITS_SERIAL As Integer = 50
    Public Const MAX_VARIANT_BLOCK_64BITS_SERIAL As Integer = 25
    Public Const MAX_VARIANT_RANDOM_BLOCK_SERIAL As Integer = 16

    ' Variant Register Structure
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_VARIANT
        Dim vRegister As Integer          'Variant Register desired
        Dim type As Integer               'Format want results returned in
        Dim precision As Integer          'Precision desired for floating point conversions
        Dim flags As Integer              'Specially defined flags, 0 for normal, (indirection, etc.)
        Dim cmd As Integer                'Special commands, 0 for normal operation
        Dim taskHandle As Integer         'Alternate task handle for local task register access, 0 = default public
        Dim slength As Integer            'Length of bytes returned in stringVar, not include null
        Dim indexCol As Integer             'Column (X) selection, base 0
        Dim indexRow As Integer             'Row (X) selection base 0
        Dim IntegerIntVar As Integer         '32 bit signed integer storage
        Dim FloatVar As Single         '32 bit float
        Dim DoubleVar As Double        '64 bit double in Microsoft format
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=223)> _
            Public stringVar() As Byte         'null terminated ASCII string of bytes (1 to 224)
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_VARIANT_BLOCK_INTEGER
        Dim vRegister As Integer          'Variant Register desired
        Dim type As Integer               'Format want results returned in
        Dim precision As Integer          'Precision desired for floating point conversions
        Dim flags As Integer              'Specially defined flags, 0 for normal, (indirection, etc.)
        Dim cmd As Integer                'Special commands, 0 for normal operation
        Dim taskHandle As Integer         'Alternate task handle for local task register access, 0 = default public
        Dim slength As Integer            'Length of bytes returned in stringVar, not include null
        Dim indexCol As Integer             'Column (X) selection, base 0
        Dim indexRow As Integer             'Row (Y) selection base 0
        Dim numAccess As Integer           'Number of items to read
        Dim rowInc As Integer              'Amount to increment row by, 0 is just read the columns
        Dim colInc As Integer              'Amount to increment column by, 0 is just read first
        Dim arraysizeCols As Integer       'Used on write operation, -1 do not expand existing columns, else columns desired.  Rows will automatically grow as needed
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=346)> _
        Public ibValue() As Integer       '(1 to 346)
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_VARIANT_BLOCK_DOUBLE
        Dim vRegister As Integer          'Variant Register desired
        Dim type As Integer               'Format want results returned in
        Dim precision As Integer          'Precision desired for floating point conversions
        Dim flags As Integer              'Specially defined flags, 0 for normal, (indirection, etc.)
        Dim cmd As Integer                'Special commands, 0 for normal operation
        Dim taskHandle As Integer         'Alternate task handle for local task register access, 0 = default public
        Dim slength As Integer            'Length of bytes returned in stringVar, not include null
        Dim indexCol As Integer             'Column (X) selection, base 0
        Dim indexRow As Integer             'Row (Y) selection base 0
        Dim numAccess As Integer           'Number of items to read
        Dim rowInc As Integer              'Amount to increment row by, 0 is just read the columns
        Dim colInc As Integer              'Amount to increment column by, 0 is just read first
        Dim arraysizeCols As Integer       'Used on write operation, -1 do not expand existing columns, else columns desired.  Rows will automatically grow as needed
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=173)> _
        Public dbValue() As Double             '(1 to 173)
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_VARIANT_BLOCK_RANDOMDOUBLE
        Dim vRegister As Integer          'Variant Register desired
        Dim type As Integer               'Format want results returned in
        Dim precision As Integer          'Precision desired for floating point conversions
        Dim flags As Integer              'Specially defined flags, 0 for normal, (indirection, etc.)
        Dim cmd As Integer                'Special commands, 0 for normal operation
        Dim taskHandle As Integer         'Alternate task handle for local task register access, 0 = default public
        Dim slength As Integer            'Length of bytes returned in stringVar, not include null
        Dim indexCol As Integer             'Column (X) selection, base 0
        Dim indexRow As Integer             'Row (Y) selection base 0
        Dim numAccess As Integer           'Number of items to read
        Dim rowInc As Integer              'Amount to increment row by, 0 is just read the columns
        Dim colInc As Integer              'Amount to increment column by, 0 is just read first
        Dim arraysizeCols As Integer       'Used on write operation, -1 do not expand existing columns, else columns desired.  Rows will automatically grow as needed
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=115)> _
        Public dbValue() As Double     '(1 to 115)
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=115)> _
        Public request() As RANDOM_VARIANT '(1 to 115)
    End Structure

    ' data table row structure
    Public Const CT_MAX_COLS As Integer = 255

    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_DT_ROW
        Dim lRow As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=255)> _
        Public lColumns() As Integer   '(1 To CT_MAX_COLS)
    End Structure

    Public Const CT_MAX_RANDOM_REGS As Integer = 50

    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_RANDOM_REGS
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=50)> _
        Public lRegList() As Integer   '(1 To CT_MAX_RANDOM_REGS)
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_ANALOG64_REGS
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
        Public lAnalogList() As Integer   '(1 To 64)
    End Structure


    ' io count structure
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_IO_COUNT
        Dim lFlags As Integer
        Dim lDigitalInputs As Integer
        Dim lDigitalOutputs As Integer
        Dim lStepperMotors As Integer
        Dim lServoMotors As Integer
        Dim lAnalogInputs As Integer
        Dim lAnalogOutputs As Integer
    End Structure

    ' misc io count structure
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_MISC_IO_COUNT
        Dim lProtoStructures As Integer
        Dim lHighSpeedCounters As Integer
        Dim lThumbwheels As Integer
        Dim lDisplays As Integer
    End Structure

    ' step status bank structure
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_TASK_BANK
        Dim lMode As Integer
        Dim lFaultCode As Integer
        Dim lFaultStep As Integer
        Dim lFaultData As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=8)> _
        Public lStep() As Integer          '(0 To 7)
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=8)> _
        Public lTaskMask1() As Integer     '(0 To 7)
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=8)> _
        Public lTaskMask2() As Integer     '(0 To 7)
    End Structure

    ' connection information structure
    ' If problem try removing the Pack line
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_CONN_INFO
        Dim lConnStructure As Integer
        Dim lSrcAddr As Integer
        Dim lDestAddr As Integer
        Dim lTimeout As Integer
        Dim fConnected As Boolean
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=6)> _
        Public srcEAddr() As Byte          '(0 To 5)
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=6)> _
        Public destEAddr() As Byte         '(0 To 5)
    End Structure

    ' message information structure
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_MSG_INFO
        Dim iMsglen As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=256)> _
        Public sMsgbuf As String ' * 256
        Dim iRsplen As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=256)> _
        Public sRspbuf As String ' * 256
    End Structure

    ' error information structure
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Public Structure CT_ERR_INFO
        Dim lCode As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=256)> _
        Public sMessage As String ' * 256
    End Structure

    ' function protoStructures (public)
    ' network access functions

    ' windows functions that may be used
    Declare Auto Function inet_addr Lib "wsock32.dll" (ByVal ipAddress As String) As Integer

    ' function prototypes (public)
    ' network access functions
    Declare Auto Function CtOpenConnection Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal CommPort As Integer, ByVal Address As Integer) As Integer
    Declare Auto Function CtInitConnection Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal BaudRate As Integer, ByVal Parity As Byte, _
        ByVal DataBits As Byte, ByVal StopBits As Byte) As Integer
    Declare Auto Function CtCloseConnection Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer) As Integer
    Declare Auto Function CtSetConnectionTimeout Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal MilliSeconds As Integer) As Integer

    ' register functions
    Declare Auto Function CtGetRegister Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal RegAddress As Integer, ByRef RegValue As Integer) As Integer
    Declare Auto Function CtGetRegister16 Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal RegAddress As Integer, ByRef Reg16Val As Integer) As Integer
    Declare Auto Function CtGetRegister50 Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal RegBank As Integer, ByRef Reg50Val As Integer) As Integer
    Declare Auto Function CtGetNRegisters Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal RegCount As Integer, ByRef RegList As Integer, ByRef Values As Integer) As Integer
    Declare Auto Function CtGetAvailableAdaptersIPList Lib "Ctccom32v2.dll" _
        (ByRef IPList As Integer, ByRef IPAdapters As Integer, ByRef numEntries As Integer) As Integer
    Declare Auto Function CtPutRegister Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal RegAddress As Integer, ByVal RegValue As Integer) As Integer
    Declare Auto Function CtGetVProperties Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal RegAddress As Integer, ByRef pSizeY_Row As Integer, ByRef pSizeX_Column As Integer, ByRef pPrecision As Integer) As Integer
    Declare Auto Function CtGetVRegister Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef Storage As CT_VARIANT) As Integer
    Declare Auto Function CtGetVRegisterBlockInteger Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef Storage As CT_VARIANT_BLOCK_INTEGER) As Integer
    Declare Auto Function CtGetVRegisterBlockDouble Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef Storage As CT_VARIANT_BLOCK_DOUBLE) As Integer
    Declare Auto Function CtGetVRegisters Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal numEntries As Integer, ByRef doneEntries As Integer, ByRef StorageList As CT_VARIANT) As Integer
    Declare Auto Function CtSetVRegisterBlockInteger Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef Storage As CT_VARIANT_BLOCK_INTEGER) As Integer
    Declare Auto Function CtSetVRegisterBlockDouble Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef Storage As CT_VARIANT_BLOCK_DOUBLE) As Integer
    Declare Auto Function CtGetVRegisterRandomBlockDouble Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef Storage As CT_VARIANT_BLOCK_RANDOMDOUBLE) As Integer
    Declare Auto Function CtSetVRegister Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef Storage As CT_VARIANT) As Integer
    Declare Auto Function CtSetVRegisters Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal numEntries As Integer, ByRef doneEntries As Integer, ByRef StorageList As CT_VARIANT) As Integer
    Declare Auto Function CtRunCommand Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef cmd As Byte, ByVal cmdLength As Integer, ByRef result As Byte, ByRef resultLength As Integer) As Integer

    ' flag functions
    Declare Auto Function CtGetFlag Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal FlagAddress As Integer, ByRef FlagValue As Integer) As Integer
    Declare Auto Function CtPutFlag Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal FlagAddress As Integer, ByVal FlagValue As Integer) As Integer

    ' digital io functions
    Declare Auto Function CtGetDigitalInput8 Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Bank As Integer, ByRef Value As Integer) As Integer
    Declare Auto Function CtGetDigitalOutput8 Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Bank As Integer, ByRef Value As Integer) As Integer
    Declare Auto Function CtGetDigitalInput128 Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Bank As Integer, ByRef Dig128Val As Integer) As Integer
    Declare Auto Function CtGetDigitalOutput128 Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Bank As Integer, ByRef Dig128Val As Integer) As Integer

    ' analog io functions
    Declare Auto Function CtGetAnalogInput Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Index As Integer, ByRef Value As Integer) As Integer
    Declare Auto Function CtGetAnalogOutput Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Index As Integer, ByRef Value As Integer) As Integer
    Declare Auto Function CtPutAnalogOutput Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Index As Integer, ByVal Value As Integer) As Integer
    Declare Auto Function CtGetAnalogInput32 Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Bank As Integer, ByRef Analog32Val As Integer) As Integer
    Declare Auto Function CtGetAnalogOutput32 Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Bank As Integer, ByRef Analog32Val As Integer) As Integer
    Declare Auto Function CtPutAnalogOutputN Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal AnalogIndex As Integer, ByVal AnalogCount As Integer, ByRef AnalogArray As CT_ANALOG64_REGS) As Integer
    Declare Auto Function CtGet2217Data Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef Data_2217 As CT_2217DATA) As Integer

    ' servo functions
    Declare Auto Function CtGetServoPosition Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Address As Integer, ByRef Value As Integer) As Integer
    Declare Auto Function CtGetServoError Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Address As Integer, ByRef Value As Integer) As Integer
    Declare Auto Function CtGetServoInputs Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Address As Integer, ByRef Value As Integer) As Integer

    ' data table functions
    Declare Auto Function CtGetDataTableDim Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef NumRows As Integer, ByRef numCols As Integer) As Integer
    Declare Auto Function CtPutDataTableDim Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal NumRows As Integer, ByVal numCols As Integer) As Integer
    Declare Auto Function CtGetDataTableLoc Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal row As Integer, ByVal col As Integer, ByRef Value As Integer) _
        As Integer
    Declare Auto Function CtPutDataTableLoc Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal row As Integer, ByVal col As Integer, ByVal Value As Integer) _
        As Integer
    Declare Auto Function CtGetDataTableRow Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal row As Integer, ByVal col As Integer, ByVal numCols As Integer, _
        ByRef DtRow As CT_DT_ROW) As Integer
    Declare Auto Function CtPutDataTableRow Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal row As Integer, ByVal col As Integer, ByVal numCols As Integer, _
        ByRef DtRow As CT_DT_ROW) As Integer

    ' status functions
    Declare Auto Function CtGetStatus Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef CtStatus As Integer) As Integer
    Declare Auto Function CtPutStatus Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal CtStatus As Integer) As Integer
    Declare Auto Function CtGetTaskBank Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Bank As Integer, ByRef TaskStatus As CT_TASK_BANK) As Integer

    ' configuration functions
    Declare Auto Function CtGetModel Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef CtModel As Integer, ByRef IsEA As Boolean) As Integer
    Declare Auto Function CtGetConfig Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef CtConfig As Integer) As Integer
    Declare Auto Function CtPutConfig Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal CtConfig As Integer) As Integer
    Declare Auto Function CtGetIoCount Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef IoCounts As CT_IO_COUNT) As Integer
    Declare Auto Function CtGetMiscIoCount Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef miscCounts As CT_MISC_IO_COUNT) As Integer

    ' program functions
    Declare Auto Function CtDownload Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Filename As String, _
        ByRef ProgramCounts As CT_PROG_COUNTS) As Integer
    Declare Auto Function CtUpload Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Filename As String, _
        ByRef ProgramCounts As CT_PROG_COUNTS) As Integer

    ' miscellaneous functions
    Declare Auto Function CtGetConnectionInfo Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef ConnInfo As CT_CONN_INFO) As Integer
    Declare Auto Function CtGetMessageInfo Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef MsgInfo As CT_MSG_INFO) As Integer
    Declare Auto Function CtGetErrorInfo Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef ErrInfo As CT_ERR_INFO) As Integer
    Declare Auto Function CtSendData Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal PktType As Integer, ByVal Pkt As String, _
        ByVal PktLen As Integer, ByVal ReturnPkt As String) As Integer
    Declare Auto Function CtSendAscii Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByVal Pkt As String, ByVal PktLen As Integer, _
        ByVal ReturnPkt As String, ByVal termChar As Byte) As Integer
    Declare Auto Function CtSetAdapter Lib "Ctccom32v2.dll" (ByVal id As Integer) As Integer

    ' devicenet / distributed module functions
    Declare Auto Function CtLoadRemoteIOConfig Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef ProgramCounts As CT_PROG_COUNTS) As Integer
    Declare Auto Function CtUnloadRemoteIOConfig Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef ProgramCounts As CT_PROG_COUNTS) As Integer
    Declare Auto Function CtGetRemoteIOData Lib "Ctccom32v2.dll" _
        (ByVal ConnectID As Integer, ByRef ProgramCounts As CT_PROG_COUNTS) As Integer


End Class